"use strict";
var __extends = (this && this.__extends)/* istanbul ignore next */ || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var base_1 = require("./../../base");
var base_2 = require("./../base");
var TsImportBinder = (function (_super) {
    __extends(TsImportBinder, _super);
    function TsImportBinder(factory, node) {
        _super.call(this, new base_2.TsBaseDefinitionBinder(), new base_2.TsNodedBinder(factory, node));
        this.factory = factory;
        this.node = node;
    }
    TsImportBinder.prototype.getFileName = function () {
        return this.node.getFileNameOfModuleSpecifier() || "";
    };
    TsImportBinder.prototype.getModuleSpecifier = function () {
        return this.node.getModuleSpecifierText() || "";
    };
    TsImportBinder.prototype.getIsStarImport = function () {
        return this.node.isStarImport();
    };
    TsImportBinder.prototype.getStarImportName = function () {
        return this.node.getStarImportName() || "";
    };
    TsImportBinder.prototype.getDefaultImport = function () {
        var defaultImportNode = this.node.getDefaultImportNode();
        return (defaultImportNode == null) ? null : this.factory.getDefaultImportPart(defaultImportNode);
    };
    TsImportBinder.prototype.getNamedImports = function () {
        var _this = this;
        return this.node.getImportNamedImportNodes().map(function (node) { return _this.factory.getNamedImportPart(node); });
    };
    TsImportBinder.prototype.getStarImports = function () {
        var _this = this;
        var starExportSymbols = this.node.getStarImportNode().getSymbol().getAliasSymbol().getExportSymbolsOfModuleByName();
        return Object.keys(starExportSymbols).filter(function (name) { return name !== "default"; }).map(function (name) {
            return _this.factory.getStarImportPart(name, starExportSymbols[name]);
        });
    };
    return TsImportBinder;
}(base_1.ImportBinder));
exports.TsImportBinder = TsImportBinder;

//# sourceMappingURL=TsImportBinder.js.map
