"use strict";
var path = require("path");
var assert = require("assert");
var main_1 = require("./../../../main");
describe("Issue #184", function () {
    var fileName = path.join(__dirname, "../../../../src/tests/issues/184/testFile.ts");
    var result = main_1.getInfoFromFiles([fileName], { includeTsNodes: true });
    var classDef = result.getFile("testFile.ts").getClass("MyClass");
    classDef.methods.forEach(function (methodDef) {
        var methodNode = methodDef.tsNode;
        methodDef.onWriteFunctionBody = function (writer) {
            methodNode.body.statements.forEach(function (statement) {
                writer.writeLine(statement.getText());
            });
        };
    });
    it("should write out the class with the method statements", function () {
        var expected = "export class MyClass {\n    myMethod() {\n        const myString = \"some string\";\n        return myString;\n    }\n}\n";
        assert.equal(classDef.write(), expected);
    });
});

//# sourceMappingURL=184.js.map
