"use strict";
var path = require("path");
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
// makes sure there's only one definition for multiple overloads
describe("function type from reference tests", function () {
    var fileName = path.join(__dirname, "../../../../src/tests/languageTests/file/testFiles/functionTypeFromReference/main.ts");
    var result = main_1.getInfoFromFiles([fileName]);
    var mainFileDef = result.getFile("main.ts");
    var referenceFileDef = result.getFile("referenceFunction.d.ts");
    testHelpers_1.runFileDefinitionTests(mainFileDef, {
        variables: [{
                name: "referenceFunctionVar",
                type: {
                    text: "typeof ReferenceFunction",
                    definitions: [{
                            name: "ReferenceFunction"
                        }]
                },
                defaultExpression: { text: "ReferenceFunction" }
            }]
    });
    testHelpers_1.runFileDefinitionTests(referenceFileDef, {
        functions: [{
                name: "ReferenceFunction",
                isAmbient: true,
                hasDeclareKeyword: true,
                parameters: [{
                        name: "param",
                        type: {
                            text: "string | number",
                            unionTypes: [{ text: "string" }, { text: "number" }]
                        }
                    }],
                overloadSignatures: [{
                        parameters: [{
                                name: "param",
                                type: { text: "number" }
                            }],
                        minArgumentCount: 1
                    }, {
                        parameters: [{
                                name: "param",
                                type: { text: "string" }
                            }],
                        minArgumentCount: 1
                    }]
            }]
    });
});

//# sourceMappingURL=functionTypeFromReferenceTests.js.map
