"use strict";
var main_1 = require("./../../../main");
var testHelpers_1 = require("./../../testHelpers");
describe("function parameter destructuring", function () {
    var code = "\nfunction parameterDestructuring({ prop1 = \"s\", prop2, prop3 }: { readonly prop1?: string; prop2?: number; prop3: Date; }) {\n}\n\nfunction implicitType({ prop1 = \"s\" }) {\n}";
    var def = main_1.getInfoFromString(code);
    testHelpers_1.runFileDefinitionTests(def, {
        functions: [{
                name: "parameterDestructuring",
                parameters: [{
                        name: null,
                        type: {
                            text: "{ readonly prop1?: string; prop2?: number; prop3: Date; }"
                        },
                        destructuringProperties: [{
                                name: "prop1",
                                type: { text: "string" },
                                defaultExpression: { text: "\"s\"" },
                                isOptional: true,
                                isReadonly: true
                            }, {
                                name: "prop2",
                                type: { text: "number" },
                                isOptional: true
                            }, {
                                name: "prop3",
                                type: { text: "Date" }
                            }]
                    }]
            }, {
                name: "implicitType",
                parameters: [{
                        name: null,
                        type: {
                            text: "{ prop1?: string; }"
                        },
                        destructuringProperties: [{
                                name: "prop1",
                                type: { text: "string" },
                                defaultExpression: { text: "\"s\"" },
                                isOptional: true
                            }]
                    }]
            }]
    });
});

//# sourceMappingURL=parameterDestructuringTests.js.map
